//------------------------------------------------------------------
#property copyright "mladen"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1  DeepSkyBlue
#property indicator_color2  Red
#property indicator_color3  Yellow
#property indicator_width1  2
#property indicator_level1  0
#import "LibSSA.dll"
   void fastSingular(double& sourceArray[],int arraySize, int lag, int numberOfComputationLoops, double& destinationArray[]);
#import

//
//
//
//
//

extern int  Length                 = 14;
extern int  Price                  = PRICE_CLOSE;
extern int  MaLength               = 8;
extern int  MaType                 = MODE_EMA;
extern int  SSABars                = 300;
extern int  SSANumComputations     = 2;
extern int  SSALag                 = 10;
extern int  SSANormalizationPeriod = 10;
extern bool Invert                 = false;

//
//
//
//
//

double rsx[];
double ma[];
double ssa[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorDigits(5);
   SetIndexBuffer(0,rsx); SetIndexLabel(0,"RSX");
   SetIndexBuffer(1,ma);  SetIndexLabel(1,"MA");
   SetIndexBuffer(2,ssa); SetIndexLabel(2,"SSA");
   IndicatorShortName("Rsx + ma + fullSSA ("+Length+","+MaLength+","+SSALag+","+SSANumComputations+","+SSANormalizationPeriod+")");
   return(0);
}
int deinit() { return(0); }

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double wrkBuffer[][16];
double ssaIn[];
double ssaOut[];
int start()
{
   double multiplier=1;
   int i,r,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         int n     = MathMin(Bars-1,SSABars);
         if (ArrayRange(wrkBuffer,0) != Bars) ArrayResize(wrkBuffer,Bars);
         if (ArraySize(ssaIn)!=n)
         {
            ArrayResize(ssaIn,n);
            ArrayResize(ssaOut,n);
         }
         if (Invert) multiplier=-1;

   //
   //
   //
   //
   //
   
   double Kg = (3.0)/(2.0+Length); 
   double Hg = 1.0-Kg;
   for(i=limit, r=Bars-i-1; i>=0; i--, r++)
   {
      wrkBuffer[r][12] = iMA(NULL,0,1,0,MODE_SMA,Price,i);

         if (i==(Bars-1)) { for (int c=0; c<12; c++) wrkBuffer[r][c] = 0; continue; }  

      //
      //
      //
      //
      //
      
      double mom = wrkBuffer[r][12]-wrkBuffer[r-1][12];
      double moa = MathAbs(mom);
      for (int k=0; k<3; k++)
      {
         int kk = k*2;
            wrkBuffer[r][kk+0] = Kg*mom                + Hg*wrkBuffer[r-1][kk+0];
            wrkBuffer[r][kk+1] = Kg*wrkBuffer[r][kk+0] + Hg*wrkBuffer[r-1][kk+1]; mom = 1.5*wrkBuffer[r][kk+0] - 0.5 * wrkBuffer[r][kk+1];
            wrkBuffer[r][kk+6] = Kg*moa                + Hg*wrkBuffer[r-1][kk+6];
            wrkBuffer[r][kk+7] = Kg*wrkBuffer[r][kk+6] + Hg*wrkBuffer[r-1][kk+7]; moa = 1.5*wrkBuffer[r][kk+6] - 0.5 * wrkBuffer[r][kk+7];
      }
      if (moa != 0)
           rsx[i] = multiplier*mom/moa; 
      else rsx[i] = 0;
      
      //
      //
      //
      //
      //
      
      wrkBuffer[r][13] = iMA(NULL,0,SSANormalizationPeriod,0,MODE_SMA,Price,i);
      wrkBuffer[r][14] = iStdDev(NULL,0,SSANormalizationPeriod,0,MODE_SMA,Price,i)*3.0;
      wrkBuffer[r][15] = multiplier*(wrkBuffer[r][12]-wrkBuffer[r][13])/MathMax(wrkBuffer[r][14],0.000000000001);
   }
   for(i=limit; i>=0; i--) ma[i] = iMAOnArray(rsx,0,MaLength,0,MaType,i);
   for(i=n-1, r=Bars-i-1; i>=0; i--,r++) ssaIn[i] = wrkBuffer[r][15];
      fastSingular(ssaIn,n,SSALag,SSANumComputations,ssaOut);
            ArrayCopy(ssa,ssaOut);
            SetIndexDrawBegin(0,Bars-n-1);
            SetIndexDrawBegin(1,Bars-n-1);
            SetIndexDrawBegin(2,Bars-n-1);
  
   //
   //
   //
   //
   //
   
   return(0);
}